package be.iminds.ilabt.jfed.experimenter_gui.dialogs;

import be.iminds.ilabt.jfed.experimenter_gui.ui.AbstractDialogFactory;
import be.iminds.ilabt.jfed.fedmon.webapi.service.json.Testbed;
import javafx.fxml.FXMLLoader;
import javafx.stage.Stage;

import javax.annotation.Nonnull;
import javax.inject.Inject;
import javax.inject.Named;
import javax.inject.Provider;
import javax.inject.Singleton;
import java.net.URL;

@Singleton
public class GDPRDialogFactory {
    private final AbstractDialogFactory dialogFactory;

    @Inject
    public GDPRDialogFactory(Provider<FXMLLoader> loaderProvider,
                             @Named("parentStage") Provider<Stage> parentStageProvider) {
        this.dialogFactory = new AbstractDialogFactory(loaderProvider, parentStageProvider) {
            @Override
            protected String getTitle() {
                return "Terms & Conditions";
            }

            @Override
            protected URL getFxmlLocation() {
                return GDPRDialogFactory.class.getResource("GDPRDialog.fxml");
            }
        };
    }

    /**
     * @param testbed
     * @return whether the user has approved the T&C (fallback: true)
     */
    public boolean showDialog(@Nonnull Testbed testbed) {
        AbstractDialogFactory.StageAndController stageAndController = this.dialogFactory.createStage();
        GDPRDialog controller = (GDPRDialog)stageAndController.getController();
        controller.setTestbed(testbed);

        stageAndController.getStage().showAndWait();

        return controller.hasApproved();
    }
}
